/************************************************************
* Este es el fichero de configuracin de la Base de Datos.
* Se crean los tablespaces.
* Se crean los usuarios y se les asignan permisos.
*
* Fecha creacin: 22/03/2021
* 
* TFG: Creacin base de datos de procesos electorales.
*
* Autor: Francisco Jos Martnez del Amo
* Tutor: Jordi Ferrer Durn
************************************************************/

CREATE TABLESPACE TFG_DATOS 
DATAFILE 'C:\oraclexe\app\oracle\oradata\XE\TFG_DATOS.DBF'
SIZE 10M 
AUTOEXTEND ON
LOGGING
PERMANENT
EXTENT MANAGEMENT LOCAL AUTOALLOCATE
BLOCKSIZE 8K
SEGMENT SPACE MANAGEMENT AUTO
FLASHBACK ON;

CREATE TEMPORARY TABLESPACE TFG_TMP
TEMPFILE 'C:\oraclexe\app\oracle\oradata\XE\TFG_TMP.DBF'
SIZE 20M;

CREATE TABLESPACE TFG_DW 
DATAFILE 'C:\oraclexe\app\oracle\oradata\XE\TFG_DW.DBF'
SIZE 10M 
AUTOEXTEND ON
LOGGING
PERMANENT
EXTENT MANAGEMENT LOCAL AUTOALLOCATE
BLOCKSIZE 8K
SEGMENT SPACE MANAGEMENT AUTO
FLASHBACK ON;

CREATE TEMPORARY TABLESPACE TFG_TMPDW
TEMPFILE 'C:\oraclexe\app\oracle\oradata\XE\TFG_TMPDW.DBF'
SIZE 20M;


CREATE USER TFG
IDENTIFIED BY 1234
DEFAULT TABLESPACE TFG_DATOS
QUOTA UNLIMITED ON TFG_DATOS
TEMPORARY TABLESPACE TFG_TMP;

GRANT
CREATE SESSION,
CREATE USER,
CREATE TABLE,
CREATE VIEW
TO TFG;

GRANT 
CREATE ANY SEQUENCE, 
ALTER ANY SEQUENCE, 
DROP ANY SEQUENCE, 
SELECT ANY SEQUENCE 
TO TFG;

GRANT 
CREATE PROCEDURE, 
CREATE TRIGGER
TO TFG;

CREATE USER DW
IDENTIFIED BY 1234
DEFAULT TABLESPACE TFG_DW
QUOTA UNLIMITED ON TFG_DW
TEMPORARY TABLESPACE TFG_TMPDW;

GRANT
CREATE SESSION
TO DW;

CREATE USER DWadmin
IDENTIFIED BY 1234
DEFAULT TABLESPACE TFG_DW
QUOTA UNLIMITED ON TFG_DW
TEMPORARY TABLESPACE TFG_TMPDW;

GRANT
CREATE SESSION,
CREATE USER,
CREATE TABLE,
CREATE VIEW
TO DWadmin;