

/* consultas frecuentes */
SELECT *FROM erroresProcedimientosABM;
SELECT * FROM PERSONA WHERE (months_between(SYSDATE,FECHANAC)/12)<=17;
SELECT *FROM LogOperaciones;
SELECT count(*) FROM Direccion;
SELECT count(*) FROM Persona;
SELECT count(*) FROM CensoElectoral;

DELETE FROM  CensoElectoral;
DELETE FROM  Voto;
DELETE FROM Recuento;
DELETE FROM Desglose;
DELETE FROM Resultado;
SELECT DISTINCT nacionalidad FROM Persona;

SELECT CentroVotacion, mesaElectoral
FROM CensoElectoral
GROUP BY CentroVotacion, mesaElectoral
ORDER BY CentroVotacion, mesaElectoral;

SELECT CentroVotacion, mesaElectoral
FROM ComunicacionVotantes
GROUP BY CentroVotacion, mesaElectoral
ORDER BY CentroVotacion, mesaElectoral;

/* selecciona 6 personas al azar de una mesa */
SELECT *
FROM 
    (SELECT *
    FROM CensoElectoral
    ORDER BY DBMS_RANDOM.VALUE) 
WHERE mesaElectoral = 10
AND ROWNUM <= 6;

SELECT numDoc, letraDoc, cargo, ID_MESA FROM MiembroMesa ORDER BY cargo;

SELECT m.ID_Mesa 
FROM MesaElectoral m
JOIN CentroVotacion c ON m.ID_Centro = c.ID_Centro
JOIN DemarcacionElectoral d ON c.ID_Demarcacion = d.ID_Demarcacion
WHERE d.ID_Proceso = 3; 

/* total nulos y blancos por demarcacin */
SELECT sum(nulos), sum(enBlanco)
FROM Recuento
WHERE ID_Mesa IN 
    (SELECT m.ID_Mesa 
    FROM MesaElectoral m
    JOIN CentroVotacion c ON m.ID_Centro = c.ID_Centro
    JOIN DemarcacionElectoral d ON c.ID_Demarcacion = 2);

/* total resultados por demarcacin */
SELECT nombrePartido, sum(totalVotos)
FROM Desglose
WHERE ID_Recuento IN 
    (SELECT r.ID_Recuento 
    FROM Recuento r
    JOIN MesaElectoral m ON r.ID_Mesa = m.Id_Mesa
    JOIN CentroVotacion c ON m.ID_Centro = c.ID_Centro
    JOIN DemarcacionElectoral d ON c.ID_Demarcacion = 2)
GROUP BY nombrePartido
ORDER BY sum(totalVotos);




/* total resultados por demarcacin */
CREATE TABLE resultadosZaragoza AS
(SELECT nombrePartido AS PARTIDO, sum(totalVotos) AS VOTOS, 0 as ESCANOS
FROM Desglose
WHERE ID_Recuento IN 
    (SELECT r.ID_Recuento 
    FROM Recuento r
    JOIN MesaElectoral m ON r.ID_Mesa = m.Id_Mesa
    JOIN CentroVotacion c ON m.ID_Centro = c.ID_Centro
    JOIN DemarcacionElectoral d ON c.ID_Demarcacion = 2)
GROUP BY nombrePartido);

BEGIN
FOR numescanos IN 1..31
LOOP
    UPDATE resultadosZaragoza SET escanos=escanos+1 
    WHERE partido = (SELECT partido 
                    FROM (SELECT partido, (votos/(escanos+1)) 
                            FROM resultadosZaragoza 
                            WHERE votos>((SELECT sum(votos) 
                                        FROM resultadosZaragoza)*5/100) 
                            ORDER BY (votos/(escanos+1)) DESC) 
                    WHERE ROWNUM <=1);
END LOOP;
END;

SELECT * FROM resultadosZaragoza ORDER BY escanos DESC;