/************************************************************
* Este es el fichero para las consultas del repositorio estadstico.
* 
*
* Fecha creacin: 11/05/2021
* 
* TFG: Creacin base de datos de procesos electorales.
*
* Autor: Francisco Jos Martnez del Amo
* Tutor: Jordi Ferrer Durn
************************************************************/

/* Proceso con ms participacin */
SELECT * FROM (SELECT ID_Proceso, totalParticipacion FROM ProcesosElectorales ORDER BY totalParticipacion DESC) WHERE ROWNUM <=1;

/* Municipio con ms participacin */
SELECT * FROM (SELECT ID_Provincia, ID_Localidad, totalParticipacion FROM Municipios  ORDER BY totalParticipacion DESC) WHERE ROWNUM <=1;

/* Porcentaje de votos telemticos en todos los procesos electorales de na fecha dada */
SELECT ID_Proceso, porcentajeTelem, fechaElecciones  FROM ProcesosElectorales WHERE fechaElecciones BETWEEN '01/01/2019' AND '31/12/2019';

/* Variacin de votos del ltimo proceso electoral respecto al anterior */
SELECT * FROM (SELECT variacionVotos FROM ProcesosElectorales ORDER BY fechaElecciones DESC) WHERE ROWNUM <=1;

/* Nmero total de personas que han formado parte de una mesa electoral ms de dos veces */
SELECT * FROM (SELECT totalMesa2Veces FROM ProcesosElectorales ORDER BY fechaElecciones DESC) WHERE ROWNUM <=1 ;

/* Porcentaje de personas seleccionadas para una mesa y presentan alegaciones */
SELECT porcentajeAlega FROM ProcesosElectorales WHERE fechaElecciones='10/11/19';

/* Nmero de partidos que se han presentado en todas las elecciones celebradas en todas las demarcaciones en los ultimos 10 aos */
SELECT * FROM (SELECT numPartDemarc FROM ProcesosElectorales ORDER BY fechaElecciones DESC) WHERE ROWNUM <=1;

/* Porcentaje de municipios que no han realizado el sondeo */
SELECT totalMunMiembros FROM ProcesosElectorales WHERE fechaElecciones='10/11/19';

/* Top20 de mesas con menos votos */
SELECT ID_Mesa, votosTotales FROM MesasElectorales WHERE ROWNUM <=20 ORDER BY votosTotales;

/* Porcentaje de personas no localizadas en el ltimo proceso electoral */
SELECT * FROM (SELECT totalLocalizado FROM ProcesosElectorales ORDER BY fechaElecciones DESC) WHERE ROWNUM <=1 ;

/* Proceso electoral con ms candidatos en total */
SELECT * FROM (SELECT ID_Proceso, totalCandidatos FROM ProcesosElectorales ORDER BY totalCandidatos DESC) WHERE ROWNUM <=1;

/* Numero total de escaos por cada partido en un proceso dado*/
SELECT ID_Partido, nombrePartido, totalEscanos FROM Partidos WHERE ID_Proceso=14 ORDER BY totalEscanos DESC; 

/* Municipio con ms porcentaje de votos telemticos */
SELECT * FROM (SELECT ID_Provincia, ID_Localidad, totalParTelem FROM Municipios  ORDER BY totalParTelem DESC) WHERE ROWNUM <=1;

/* Variacin del voto telemtico de un proceso frente al anterior */
SELECT * FROM (SELECT variacionTelem FROM ProcesosElectorales ORDER BY fechaElecciones DESC) WHERE ROWNUM <=1;

/* Variacin de escaos de cada partido respecto a las anteriores elecciones en un proceso dado*/
SELECT ID_Partido, nombrePartido, variacionEscanos FROM Partidos WHERE ID_Proceso=14 ORDER BY variacionEscanos DESC; 
