/************************************************************
* Este es el fichero para crear las tablas del Data Warehouse.
* 
*
* Fecha creacin: 11/05/2021
* 
* TFG: Creacin base de datos de procesos electorales.
*
* Autor: Francisco Jos Martnez del Amo
* Tutor: Jordi Ferrer Durn
************************************************************/

/* Creacin de las tablas de hechos */

CREATE TABLE Partidos(
    ID_Proceso INTEGER,
    ID_Partido INTEGER,
    nombrePartido VARCHAR2(50),
    siglas VARCHAR2(15),
    fechaElecciones DATE,
    totalCandidatos INTEGER,
	totalEscanos INTEGER,
	todasDemarcaciones CHAR(1) CONSTRAINT B_todasDemarcaciones CHECK (todasDemarcaciones IN('S','N')),
	variacionEscanos NUMBER
);

CREATE TABLE ProcesosElectorales(
    ID_Proceso INTEGER,
	ambito VARCHAR2(11),
	fechaElecciones DATE,
	nombreProceso VARCHAR2(80),
	totalParticipacion NUMBER,
	personasCensadas NUMBER,
	votosTotales NUMBER,
	votosTelematicos NUMBER,
	porcentajeTelem NUMBER,
	variacionVotos NUMBER,
	variacionTelem NUMBER,
	totalCandidatos NUMBER,
	totalMunicipios INTEGER,
	totalMunMiembros NUMBER,
	totalMesa2Veces INTEGER,
	totalSeleccion INTEGER,
	totalLocalizado INTEGER,
	porcentajeAlega NUMBER,
    porcentajeNoLoc NUMBER,
	numPartDemarc INTEGER
);

CREATE TABLE Municipios (
	ID_Provincia INTEGER, 
    ID_Localidad INTEGER, 
	ID_Proceso INTEGER,
    fechaElecciones DATE,
	totalParticipacion NUMBER,
	totalParTelem NUMBER,
	personasCensadas NUMBER,
	votosTotales NUMBER,
	votosTelematicos NUMBER,
	variacionesVotos NUMBER,
	totalCandidatos NUMBER
);

CREATE TABLE MesasElectorales(
    ID_Mesa NUMBER,
    ID_Proceso INTEGER,
	fechaElecciones DATE,
	totalSeleccion INTEGER,
	totalLocalizado INTEGER,
	totalAlegaciones INTEGER,
	totalAptos INTEGER,
	personasCensadas NUMBER,
	votosTotales NUMBER,
	votosTelematicos NUMBER
);

