/************************************************************
* Este es el fichero de prueba de los procedimientos 
*
*
* Fecha creacin: 24/03/2021
* 
* TFG: Creacin base de datos de procesos electorales.
*
* Autor: Francisco Jos Martnez del Amo
* Tutor: Jordi Ferrer Durn
************************************************************/

/* Pruebas Gobierno */
DECLARE
RSP VARCHAR2(500);
BEGIN
    /* Correctos */
    altaGobierno (999, 'General', 'Pruebas', RSP);
    modGobierno (999, 'Local', 'Pruebas Modificado', RSP);
    modGobierno (999, 'General', 'Pruebas Modificado', RSP);
    bajaGobierno (999, RSP);
    /* Repetidos */
    altaGobierno (3, 'General', 'Gobierno de Espaa', RSP);
    altaGobierno (Sec_Gobierno.NEXTVAL, 'General', 'Gobierno de Espaa', RSP);
    altaGobierno (Sec_Gobierno.CURRVAL, 'Local', 'Ayuntamiento de Zaragoza', RSP);
    modGobierno (Sec_Gobierno.NEXTVAL, 'General', 'Gobierno de Espaa', RSP);
    /* Nulos */
    altaGobierno (Sec_Gobierno.NEXTVAL, NULL, 'Gobierno de Espaa', RSP);
    modGobierno (1, NULL, NULL, RSP);
    /* No Existe */
    modGobierno (999, 'General', 'Gobierno de Espaa', RSP);
    bajaGobierno (999, RSP);
END;
/

/* Pruebas Proceso Electoral */
DECLARE
RSP VARCHAR2(500);
BEGIN
    /* Correctos */
    altaProcesoElectoral (Sec_ProcesoElectoral.NEXTVAL, 'Local', '26/05/2019', 'Elecciones Ayuntamiento de Zaragoza 2019', 3, RSP);
    altaProcesoElectoral (999, 'Local', '30/10/2019', 'Elecciones Ayuntamiento de Utebo 2019', 3, RSP);
    modProcesoElectoral (999, 'Local', '02/04/2019', 'Elecciones Ayuntamiento de Utebo 2019', 3, RSP);
    bajaProcesoElectoral (999, RSP);
    /* Repetidos */
    altaProcesoElectoral (Sec_ProcesoElectoral.NEXTVAL, 'Local', '26/05/2019', 'Elecciones Ayuntamiento de Zaragoza 2019', 3, RSP);
    altaProcesoElectoral (1, 'Local', '26/05/2019', 'Elecciones Ayuntamiento de Zaragoza 2019', 3, RSP);
    /* Nulos */
    altaProcesoElectoral (Sec_ProcesoElectoral.NEXTVAL, NULL, '26/05/2019', 'Elecciones prueba NULL', 3, RSP);
    modProcesoElectoral (2, NULL, NULL, NULL, NULL, RSP);
    /* No Existe */
    modProcesoElectoral (999, 'Local', '02/04/2019', 'Elecciones Ayuntamiento de Utebo 2019', 3, RSP);
    bajaProcesoElectoral (999, RSP);
  END;
/  

/* Pruebas Provincias */
DECLARE
RSP VARCHAR2(500);
BEGIN
    /* Correctos */
    altaProvincia (53, 'Prueba', 1,1,RSP);
    modProvincia (53, 'TFG', 1,1,RSP);
    bajaProvincia (53, RSP);
    /* Repetidos */
    altaProvincia (1, 'Prueba', 1,1,RSP);
    altaProvincia (53, 'Zaragoza', 1,1,RSP);
    modProvincia (52, 'Zaragoza', 1,1,RSP);
    /* Nulos */
    altaProvincia (53, NULL, 1,1,RSP);
    altaProvincia (NULL, NULL, 1,1,RSP);
    modProvincia (NULL, NULL, 1,1,RSP);
    modProvincia (52, NULL, 1,1,RSP);
    /* No Existe */
    modProvincia (999, 'TFG', 1,1,RSP);
    bajaProvincia (999, RSP);
  END;
/ 

/* Pruebas localidades */
DECLARE
RSP VARCHAR2(500);
BEGIN
    /* Correctos */
    altaLocalidad (01,999,'prueba', 1, RSP);
    modLocalidad (01,999,'pruebaOK', 1, RSP);
    bajaLocalidad (01,999, RSP);
    altaLocalidad (01,999,'prueba', 1, RSP);
    /* Repetidos */
    altaLocalidad (01,999,'prueba', 1, RSP);
    altaLocalidad (02,999,'prueba', 1, RSP);
    modLocalidad (01,999, 'Zaragoza', 1, RSP);
    /* Nulos */
    altaLocalidad (01,999,NULL, 1, RSP);
    altaLocalidad (NULL,NULL,'prueba', 1, RSP);
    modLocalidad (NULL,NULL, 'Zaragoza', 1, RSP);
    modLocalidad (50,297, NULL, 1, RSP);
    /* No Existe */
    modLocalidad (05,999,'pruebaOK', 1, RSP);
    bajaLocalidad (01,999, RSP); /* borramos de verdad */
    bajaLocalidad (01,999, RSP); 
  END;
/ 

/* Pruebas Partidos Politicos */
DECLARE
RSP VARCHAR2(500);
BEGIN
    /* Correctos */
    altaPartidoPolitico(999,'Pruebas','P',RSP);
    modPartidoPolitico(999,'PruebasOK','P',RSP);
    bajaPartidoPolitico(999,RSP);
    altaPartidoPolitico(999,'Pruebas','P',RSP);
    /* Repetidos */
    altaPartidoPolitico(999,'Pruebas','P',RSP);
    altaPartidoPolitico(998,'Vox','P',RSP);
    modPartidoPolitico(999,'Vox','P',RSP);
    /* Nulos */
    altaPartidoPolitico(998,NULL,'P',RSP);
    modPartidoPolitico(NULL,NULL,'P',RSP);
    modPartidoPolitico(999,NULL,'P',RSP);
    /* No Existe */
    modPartidoPolitico(998,'PruebasOK','P',RSP);
    bajaPartidoPolitico(999,RSP); /* correcto */
    bajaPartidoPolitico(999,RSP);
    END;
/ 

/* Pruebas Mtodo de Clculo */
DECLARE
RSP VARCHAR2(500);
BEGIN
    /* Correctos */
    altaMetodoCalculo(999,'Pruebas', RSP);
    modMetodoCalculo(999,'PruebasOK', RSP);
    bajaMetodoCalculo(999,RSP);
    altaMetodoCalculo(999,'Pruebas',RSP);
    /* Repetidos */
    altaMetodoCalculo(999,'Pruebas',RSP);
    /* Nulos */
    altaMetodoCalculo(998,NULL,RSP);
    modMetodoCalculo(NULL,NULL,RSP);
    modMetodoCalculo(999,NULL,RSP);
    /* No Existe */
    modMetodoCalculo(998,'PruebasOK',RSP);
    bajaMetodoCalculo(999,RSP); /* correcto */
    bajaMetodoCalculo(999,RSP);
    END;
/ 

/* Pruebas Reglas de Proceso */
DECLARE
RSP VARCHAR2(500);
BEGIN
    /* Correctos */
    altaReglaProceso(999,'Pruebas','pruebas', RSP);
    modReglaProceso(999,'PruebasOK','pruebas', RSP);
    bajaReglaProceso(999,RSP);
    altaReglaProceso(999,'Pruebas','pruebas',RSP);
    /* Repetidos */
    altaReglaProceso(999,'Pruebas2','pruebas2', RSP);
    /* Nulos */
    altaReglaProceso(998,NULL, NULL, RSP);
    altaReglaProceso(NULL,'Pruebas','pruebas', RSP);
    modReglaProceso(NULL,'PruebasOK','pruebas', RSP);
    modReglaProceso(999,NULL,NULL, RSP);
    /* No Existe */
    modReglaProceso(998,'PruebasOK','no existe', RSP);
    bajaReglaProceso(999,RSP); /* correcto */
    bajaReglaProceso(999,RSP);
    END;
/ 

/* Pruebas Reglas de Partidos Polticos */
DECLARE
RSP VARCHAR2(500);
BEGIN
    /* Correctos */
    altaReglasPartidosPoliticos(999,'Pruebas','pruebas', RSP);
    modReglasPartidosPoliticos(999,'PruebasOK','pruebas', RSP);
    bajaReglasPartidosPoliticos(999,RSP);
    altaReglasPartidosPoliticos(999,'Pruebas','pruebas',RSP);
    /* Repetidos */
    altaReglasPartidosPoliticos(999,'Pruebas2','pruebas2', RSP);
    /* Nulos */
    altaReglasPartidosPoliticos(998,NULL, NULL, RSP);
    altaReglasPartidosPoliticos(NULL,'Pruebas','pruebas', RSP);
    modReglasPartidosPoliticos(NULL,'PruebasOK','pruebas', RSP);
    modReglasPartidosPoliticos(999,NULL,NULL, RSP);
    /* No Existe */
    modReglasPartidosPoliticos(998,'PruebasOK','no existe', RSP);
    bajaReglasPartidosPoliticos(999,RSP); /* correcto */
    bajaReglasPartidosPoliticos(999,RSP);
    END;
/ 

/* Pruebas Demarcacin Electoral */
DECLARE
RSP VARCHAR2(500);
BEGIN
    /* Correctos */
    altaDemarcacionElectoral(999,'Prueba',10,1, RSP);
    modDemarcacionElectoral(999,'Prueba2',15,1,RSP);
    bajaDemarcacionElectoral(999, RSP);
END;
/ 
/* Pruebas Centro de Votaciones */
DECLARE
RSP VARCHAR2(500);
BEGIN
    /* Correctos */
    altaCentroVotacion(999,'Colegio de Prueba','calle Sagasta',50, 297, 3, RSP);
    modCentroVotacion(999,'Colegio de Prueba 2','calle Modificada',50, 297, 3, RSP);
    bajaCentroVotacion(999, RSP);
END;
/

/* Pruebas Mesa Electoral */
DECLARE
RSP VARCHAR2(500);
BEGIN
    /* Correctos */
    altaMesaElectoral(999,'Mesa 1', 999, RSP);
    modMesaElectoral(999,'Mesa 2', 999, RSP);
    bajaMesaElectoral(999, RSP);
END;
/

/* Pruebas Comunicacin BOE */
DECLARE
RSP VARCHAR2(4000);
BEGIN
    /* Correctos */
    altaComunicacionBOE(999,'Local', '26/05/2019', 'prueba', 'DHONT', 'Zaragoza', '31',3, RSP);
    modComunicacionBOE(999,'Local', '26/05/2019', 'NO', 'OTRO', 'Zaragoza', '31',3, RSP);
    bajaComunicacionBOE(999, RSP);
END;
/

/* Pruebas ParticipaEn */
DECLARE
RSP VARCHAR2(4000);
BEGIN
    /* Correctos */
    altaParticipaEn(3, 2, 3, RSP);
    /* NO SE PUEDEN MODIFICAR, SON UNICOS */
    bajaParticipaEn(3, 2, 3, RSP);
END;
/

/* Pruebas Voto */
DECLARE
RSP VARCHAR2(4000);
BEGIN
    /* Correctos */
    altaVoto(999,'presencial', 'Podemos', 'normal', 3, RSP);
    modVoto(999,'presencial', 'Partido Popular', 'nulo', 3, RSP);
    bajaVoto(999, RSP);
END;
/

/* Pruebas Censo Electoral */
DECLARE
RSP VARCHAR2(4000);
BEGIN
    /* Erroneos */
    altaCensoElectoral(999,'k', 1, 3, '26/05/2019', 'S', 3, 2, NULL, RSP);
	altaCensoElectoral(NULL,'k', 1, 3, '26/05/2019', 'S', 3, 2, NULL, RSP);
    modCensoElectoral(999,'k', 1, 3, '26/05/2019', 'N', 5, 5, NULL, RSP);
	modCensoElectoral(NULL,'k', 1, 3, '26/05/2019', 'N', 5, 5, NULL, RSP);
    bajaCensoElectoral(999, 'k', 1, 3, RSP);
END;
/

/* Pruebas Comunicacin votantes */
DECLARE
RSP VARCHAR2(4000);
BEGIN
    /* Erroneos */
    altaComunicacionVotantes(999, 999,'k', 2, 3, 'instrucciones', 3, RSP);
	altaComunicacionVotantes(NULL, NULL,'k', 2, 3, 'instrucciones', 3, RSP);
    modComunicacionVotantes(999, 999,'k', 5, 5, 'instrucciones', 3, RSP);
	modComunicacionVotantes(NULL, NULL,'k', 5, 5, 'instrucciones', 3, RSP);
    bajaComunicacionVotantes(999, RSP);
END;
/

/* Pruebas Lista de Candidatos */
DECLARE
RSP VARCHAR2(4000);
BEGIN
    /* Correctos */
    altaListaCandidatos(999,'S', 2, 2, 3, RSP);
    modListaCandidatos(999,'N', 2, 2, 3, RSP);  
    bajaListaCandidatos(999, RSP);
END;
/

/* Pruebas Candidatos */
DECLARE
RSP VARCHAR2(4000);
BEGIN
    /* Correctos */
    altaCandidato(4000000,'J', 3, 'Paco','Martinez','Martinez', 3, RSP);
    modCandidato(4000000,'J', 3, 'Francisco','Martinez','Perez', 3, RSP);
    bajaCandidato(4000000,'J', RSP);
END;
/

/* Pruebas Recuento */
DECLARE
RSP VARCHAR2(4000);
BEGIN
    /* Correctos */
    altaRecuento(999, 100, 100, 3, RSP);
    modRecuento(999, 100, 100, 3, RSP);
    bajaRecuento(999, RSP);
END;
/

/* Pruebas Desglose */
DECLARE
RSP VARCHAR2(4000);
BEGIN
    /* Correctos */
    altaDesglose(3,999, 'Podemos', 100, RSP);
    modDesglose(3,999, 'Podemos', 100, RSP);
    bajaDesglose(3, 999, RSP);
END;
/

/* Pruebas Resultado */
DECLARE
RSP VARCHAR2(4000);
BEGIN
    /* Correctos */
    altaResultado(2,2, 1, '26/05/2107', RSP);
    modResultado(2,2, 1, '15/05/2007', RSP);
    bajaResultado(2,2, 1, RSP);
END;
/

/* Pruebas Reglas de seleccin */
DECLARE
RSP VARCHAR2(4000);
BEGIN
    /* Correctos */
    altaReglasSeleccion(999,'Pruebas','pruebas', RSP);
    modReglasSeleccion(999,'PruebasOK','pruebas', RSP);
    bajaReglasSeleccion(999,RSP);
    altaReglasSeleccion(999,'Pruebas','pruebas',RSP);
    /* Repetidos */
    altaReglasSeleccion(999,'Pruebas2','pruebas2', RSP);
    /* Nulos */
    altaReglasSeleccion(998,NULL, NULL, RSP);
    altaReglasSeleccion(NULL,'Pruebas','pruebas', RSP);
    modReglasSeleccion(NULL,'PruebasOK','pruebas', RSP);
    modReglasSeleccion(999,NULL,NULL, RSP);
    /* No Existe */
    modReglasSeleccion(998,'PruebasOK','no existe', RSP);
    bajaReglasSeleccion(999,RSP); /* correcto */
    bajaReglasSeleccion(999,RSP);
END;
/

/* Pruebas Miembros de mesa */
DECLARE
RSP VARCHAR2(4000);
BEGIN
    /* Correctos */
    altaMiembroMesa(999,'k', 1, 3, 1, 3, '26/05/2019', 'Presidente', 'S', 'S', 'S', RSP);
	altaMiembroMesa(NULL,'k', 1, 3, 1, 3, '26/05/2019', 'Presidente', 'S', 'S', 'S', RSP);
    modMiembroMesa(999,'k', 1, 3, 1, 3, '26/05/2019', 'Presidente', 'S', 'S', 'S', RSP);
	modMiembroMesa(NULL,'k', 1, 3, 1, 3, '26/05/2019', 'Presidente', 'S', 'S', 'S', RSP);
    bajaMiembroMesa(999,'k', 1, 3, 1, 3, RSP);
END;
/
